#ifndef dm_seq_bank_H
#define dm_seq_bank_H

/* Databank of filtered DNA sequences */
/* Last edited on 2006-02-28 13:56:55 by stolfi */

#include <dm_basic.h>
#include <dm_seq.h>
#include <vec.h>

vec_typedef(dm_seq_vec_t,dm_seq_vec,dm_seq_t);
  /* Vector of {dm_seq_t}. */

typedef struct dm_seq_bank_t {
    int r;              /* Sampling order (0 = original). */
    dm_seq_vec_t seq;   /* The sequences. */
  } dm_seq_bank_t;
  /* A set of sequences. */
  
dm_seq_bank_t dm_seq_bank_read(char *dbName, char *seqDir);
  /* Reads a data bank of DNA sequences, which is described by the file
    "{dbName}.gdb". The file must have a standard header, followed
    by a line "nseq = {N}", followed by {N} sequence names {name[i]},
    and a standard file footer. Sequence {i} is read from file
    "{seqDir}/{name[i]}.bas". */



#endif
